package api

import (
	"box-cost/db/model"
	"time"

	"github.com/gin-gonic/gin"
)

func Setting(router *GinRouter) {

	CreateCRUD(router, "/units", &CRUDOption{
		Collection: "units",
		NewModel: func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
			entity := &model.Unit{}
			c.ShouldBindJSON(entity)
			entity.CreateTime = time.Now()
			return entity, nil
		},
		EmtyModel: func(c *gin.Context, apictx *ApiSession) interface{} {
			return &model.Unit{}
		},
		JWT:           true,
		SearchProject: []string{"name", "createTime"},
	})

	CreateCRUD(router, "/cates", &CRUDOption{
		Collection: "cates",
		NewModel: func(c *gin.Context, apictx *ApiSession) (interface{}, error) {
			entity := &model.Category{}
			c.ShouldBindJSON(entity)
			entity.CreateTime = time.Now()
			return entity, nil
		},
		EmtyModel: func(c *gin.Context, apictx *ApiSession) interface{} {
			return &model.Category{}
		},
		JWT:           true,
		SearchProject: []string{"name", "createTime"},
	})
}
