package model

import (
	"time"

	"go.mongodb.org/mongo-driver/bson/primitive"
)

// 包装
type Pack struct {
	Id        primitive.ObjectID `bson:"_id,omitempty" json:"_id"`
	Name      string             `bson:"name,omitempty" json:"name"`
	Thumbnail string             `bson:"thumbnail,omitempty" json:"thumbnail"`
	// 部件数量
	CompCounts int `bson:"compCounts,omitempty" json:"compCounts"`
	// 设计师
	Designer string `bson:"designer,omitempty" json:"designer"`
	// 组成包装的部件
	Components []*PackComponent `bson:"components,omitempty" json:"components"`
	CreateTime time.Time        `bson:"createTime,omitempty" json:"createTime"`
	UpdateTime time.Time        `bson:"updateTime,omitempty" json:"updateTime"`
}

type PackComponent struct {
	Id        string `bson:"id,omitempty" json:"id"`
	Name      string `bson:"name,omitempty" json:"name"`
	Thumbnail string `bson:"thumbnail,omitempty" json:"thumbnail"`
	//数量
	Count int `bson:"count,omitempty" json:"count"`

	//刀版图
	Uv string `bson:"uv,omitempty" json:"uv"`

	//部件尺寸
	UvSize string `bson:"uvSize,omitempty" json:"uvSize"`

	//所有材料
	Mats []*PackComponentMat `bson:"mats,omitempty" json:"mats"`

	Remark string `bson:"remark,omitempty" json:"remark"`
}

type PackComponentMat struct {
	Id string `bson:"id,omitempty" json:"id"`

	//所有工艺
	Crafts []*PackComponentMatCraft `bson:"crafts,omitempty" json:"crafts"`

	MatInfo *Material `bson:"matInfo,omitempty" json:"matInfo"` //材料Id
}

type PackComponentMatCraft struct {
	Id string `bson:"id,omitempty" json:"id"`

	//工艺尺寸
	Size string `bson:"size,omitempty" json:"size"`

	//工艺数量
	Count int `bson:"count,omitempty" json:"count"`

	//工艺信息
	CraftInfo *Craft `bson:"craftInfo,omitempty" json:"craftInfo"` //材料Id
}
